{{ $read_tags := true }}

{{ $fontSmall := .Page.Params.design.font_size_min | default 0.9 }}
{{ $fontBig := .Page.Params.design.font_size_max | default 1.9 }}
{{ $fontDelta := sub $fontBig $fontSmall }}

{{/* read "tags"... */}}
{{ $data := .Site.Taxonomies.tags.ByCount }}

{{/* output goes here... */}}

{{ if ne (len $data) 0 }}

<style>
    .tag-cloud-tags {
        display: block;
        margin: 2rem;
        list-style-type: none;
    }
    .tag-cloud-tags a {
        display: inline-block;
        margin: .5rem;
        padding: .9rem;
        line-height: .3em;
        word-break: break-word;
        white-space: normal;
        text-decoration: none;
        border-bottom: 1px solid LightGrey;
        color: #279543;
    }
    .tag-cloud-tags a:nth-child(5n+1) { transform: rotate(-2deg); }
    .tag-cloud-tags a:nth-child(3n+3) { transform: rotate(1deg); }
    .tag-cloud-tags a:nth-child(3n+4) { transform: rotate(-3deg); }
    .tag-cloud-tags a:nth-child(5n+5) { transform: rotate(3deg); }

    /* underline animation from left */

    .hover-animate-from-left {
        display: inline-block;
        vertical-align: middle;
        -webkit-transform: perspective(1px) translateZ(0);
        transform: perspective(1px) translateZ(0);
        box-shadow: 0 0 1px rgba(0, 0, 0, 0);
        position: relative;
        overflow: hidden;
    }
    .hover-animate-from-left:before {
        content: "";
        position: absolute;
        z-index: -1;
        left: 0;
        right: 100%;
        bottom: 0;
        background: #30d158;
        height: 2px;
        -webkit-transition-property: right;
        transition-property: right;
        -webkit-transition-duration: 0.8s;
        transition-duration: 0.8s;
        -webkit-transition-timing-function: ease-out;
        transition-timing-function: ease-out;
    }

    .hover-animate-from-left:hover:before,
    .hover-animate-from-left:focus:before,
    .hover-animate-from-left:active:before {
        right: 0;
    }
</style>

{{ $max := add (len (index $data 0).Pages) 1 }}
{{ $min := len (index ($data).Reverse 0).Pages }}
{{ $delta := sub $max $min }}
{{ $fontStep := div $fontDelta $delta }}

<div class="row" style="background-color:#FAFAFA;padding:5px">
    <div class="heading text-center" style="margin-top:5px">

        <div class="col-12 text-center">

            <div class="tag-cloud-tags">
                {{ range $item := (sort $data ".Page.Title" "asc") }}

                {{ $tagCount := len $item.Pages }}
                {{ $weight := div (sub (math.Log $tagCount) (math.Log $min)) (sub (math.Log $max) (math.Log $min)) }}
                {{ $fontSize := add $fontSmall (mul (sub $fontBig $fontSmall) $weight) }}

                {{ if ne (upper .Page.Title) "ARCHIVED" }}
                <a href="{{ .Page.RelPermalink }}" style="font-size:{{ $fontSize }}rem" class="hover-animate-from-left">
                    {{- .Page.Title | upper -}}
                    <span style="color: LightGrey; font-size:{{ $fontSmall }}rem"> ({{ $tagCount }}) </span>
                </a>
                {{ end }}

                {{ end }}
            </div>

        </div>
    </div>
</div>
{{ end }}